/* abcAJUDA - Programa de documentao sobre ABC, abcm2ps e postscript
 * Copyright (C) 2004 Hudson Lacerda
 */

/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


// Se for compilar para Windows 16bit (EasyWin), ser necessrio usar a definio abaixo:
// #define EASY_WIN // Isso impede o uso da funo system() (comandos ls e dir)

#define LINUX
#define LISTAGEM // permite usar os comandos ls e dir

#ifdef LINUX
#define getch getchar // usar em Linux
#define strcmpi strcasecmp //usar em Linux
#endif


#ifdef EASY_WIN
#define PAUSAR 1
#endif
#ifdef LINUX
#define PAUSAR 1
#else
#define PAUSAR 0
#endif


//#ifndef EASY_WIN
//	#include <dos.h>
//#endif
//#include <conio.h>

#include <stdio.h>
#include <string.h>
#include <strings.h>
#include <stdlib.h>
#include <math.h>


#define SIM 1
#define NAO 0

#define ENTRADA  stdin
#define SAIDA    stdout
#define ERRO     stderr
#define NOME_ARQ_AJUDA "abcAJUDA.txt"


#define NOME_DIR_AJUDA "arq" // se mudar isso, mude tambm LIST_COMAND
#define EXT_ARQ_AJUDA ".txt" // se mudar isso, mude tambm LIST_COMAND
#ifdef LINUX
#define LIST_COMMAND "cd %s; ls -RF\n" // unix
#else
#define LIST_COMMAND "dir /W /S  %s \n" // dos
#endif

#define TOPICO_DEFAULT "???"
#define SINAL_NOME_TOPICO '@'
#define SINAL_INICIO_TOPICO '$'
#define SINAL_FIM_TOPICO '$'
#define TODOS_OS_TOPICOS " "

// SEPARADOR DE DIRETORIO
#ifdef LINUX
#define DIRSEP '/' // unix
#else
#define DIRSEP '\\' // dos
#endif

FILE *arq_ent, *arq_saida;


int pausar = PAUSAR;

char chamada[BUFSIZ];
char arquivo_pesquisa[BUFSIZ];
char diretorio_pesquisa[BUFSIZ];
#define MAXLIN BUFSIZ

char *lista1[] = {
   "AJUDA", // AJUDA DO PROGRAMA
   "A", // CHAMA A AJUDA PARA TPICO EM ARQUIVO
   "?", // problemas em certos terminais linux
   "ARQ", // MUDA DE ARQUIVO DE PESQUISA
   "LS", // LISTA ARQUIVOS DE PESQUISA
   "DIR", // LISTA ARQUIVOS DE PESQUISA
   "PAUSA" // ATIVA/DESATIVA PAUSA QUANDO IMPRIME UMA TELA CHEIA
};
#define N_LISTA1   (sizeof(lista1)/sizeof(char*))

int lelinha(char s[], int lim, FILE *arquivo); //le linha do arquivo
int proxpal(char s[],char pal[],int *pos,int lim);
//le proxima palavra da string s, retorna tamanho da palavra
int separador(char c); //testa se caracter  separador
//lista de separadores embutida
int ident_com(char pal[],char *lista[],int n_com);
//identifica comando, retorna -1 se no reconhece
int ajuda(char pal[]);  //le arquivo de ajuda, buscando topico pal
//int lenumero(char s[]);   //le numero da entrada
//int conv_num(char s[], double *num); //converte string a numero
//int acao1(void);
//int acao2(void);
//int acao3(void);
//int acao4(void);
int impr_saida(char s[]);
int impr_erro(char s[]);



int main(int argc, char* argv[])
{


   int terminar;
   char lin[MAXLIN];
   int tam, p;
   //double numero;
   char palavra[MAXLIN];
   int com;
   int i;


   /*
     int controle;
     controle = 0;
     #define NUMERO 19
   */
   //printf("\ntamanho da lista1 (nmero de palavras para comandos) = %d\n",N_LISTA1);
   ///////////////////////diretorio do arquivo de ajuda - INICIO
   chamada[0]='\0';
   //for(i=0; i<argc; i++) {
   //	  printf("i=%d, argv[i]=%s\n",i,argv[i]);
   //}

   strcpy(chamada,argv[0]); //copia o nome pelo qual o programa foi chamado
   //printf("chamada=<%s>\n",chamada);
   //printf("---i=%n\n",i);
   i=(int)strlen(chamada);
   //printf("i=%d\n",i);
   while(((--i)>=0) && (chamada[i]!=DIRSEP))
      ;
   if(i>=0)
      chamada[i+1]='\0';
   //else
   //	chamada[0]='\0';

   //printf("i=%d\n%s\n",i,chamada);


   //linux
   

   strcpy(arquivo_pesquisa, NOME_ARQ_AJUDA);

   //strcpy(diretorio_pesquisa,chamada); // no em linux

   strcat(diretorio_pesquisa,NOME_DIR_AJUDA);
   i=strlen(diretorio_pesquisa);
   diretorio_pesquisa[i]=DIRSEP; diretorio_pesquisa[i+1]='\0';
   fprintf(SAIDA,"diretorio_pesquisa = :%s:",diretorio_pesquisa);
   /////////////////////diretorio do arquivo de ajuda - FIM


   arq_ent = ENTRADA;
   arq_saida = SAIDA;

   //printf("\n\n****************************************************\n\n");
   fprintf(SAIDA,"\n\n\n\tabcAJUDA - ");
   fprintf(SAIDA,"HUDSON LACERDA (2004)\n\n");
   fprintf(SAIDA,"\tUm programa para acessar documentao de ABC Plus\n\n\n");
   fprintf(SAIDA,"O comando \"fim\" conclui o programa.\n");
   fprintf(SAIDA,"O comando \"ajuda\" lista os comandos disponveis.\n");
   fprintf(SAIDA,"\nDigite um comando e pressione <Enter>:\n");

   terminar = 0;
   //   while(!terminar && controle++<NUMERO) {
   while(!terminar) {
      fprintf(SAIDA,"\n>");
      tam = lelinha(lin,MAXLIN,arq_ent);

      p=0;
      if(proxpal(lin,palavra,&p,tam)) {
	 if(!strcmpi(palavra,"fim") ||
	    !strcmpi(palavra,"exit") ||
	    !strcmpi(palavra,"quit")) {
	    fprintf(arq_saida,"\nCONCLUDO\n");
	    terminar = 1;
	    exit(0); //termina aqui
	    //return; //termina no teste de 'terminar'
	 }
	 //printf("Palavra: %s\n",palavra);
	 if((com=ident_com(palavra,lista1,N_LISTA1))==-1)
	    fprintf(SAIDA,"\nCOMANDO DESCONHECIDO: %s\n",palavra);
	 else {
	    //printf("IDENTIFICADO: %s\n",lista1[com]);
	    //executar comando
	    switch (com) {
	    case 0: //ajuda
	       fprintf(SAIDA,"\nEste  o programa abcAJUDA (Hudson Lacerda/2004)\n");
	       fprintf(SAIDA,"\n");
	       fprintf(SAIDA,"COMANDOS:\n\n");
	       fprintf(SAIDA,"ajuda\t\tExibe esta mensagem\n"); //ajuda
	       //fprintf(SAIDA,"\n");
	       fprintf(SAIDA,
		       "a\n?\t\tLista tpicos de ajuda disponveis no arquivo atual\n"); // ?
	       //fprintf(SAIDA,"\n");
	       fprintf(SAIDA,
		 "a <tpico>\n? <tpico>\tConsulta um tpico em um arquivo de ajuda\n"); // ?
	       fprintf(SAIDA,"\tEXEMPLO:\n");
	       fprintf(SAIDA,"\t? LEIA-ME\n");
	       //fprintf(SAIDA,"\n");
	       fprintf(SAIDA,"arq <nome>\tMuda para o arquivo de ajuda indicado\n"); // arq
	       fprintf(SAIDA,"\tEXEMPLO:\n");
	       fprintf(SAIDA,"\tarq abcAJUDA.txt\n");
	       fprintf(SAIDA,"ls\t\tLista arquivos do diretrio de documentao\n"); // ls
	       //fprintf(SAIDA,"\n");
	       fprintf(SAIDA,"dir\t\tO mesmo que ls\n"); // dir
	       //fprintf(SAIDA,"\n");
	       fprintf(SAIDA,"pausa\t\tAtiva/desativa pausa entre telas\n");
	       fprintf(SAIDA,"\t\t(para leitura de textos longos)\n");
	       //fprintf(SAIDA,"\n");
	       fprintf(SAIDA,"fim\t\tEncerra o programa.\n"); //fim
	       fprintf(SAIDA,"\n");

	       break;
	    case 1: // A - pesquisa um topico
	    case 2: // ?

	       proxpal(lin,palavra,&p,tam);

	       //strcpy(arquivo_pesquisa,palavra);
	       ajuda(palavra);
	       break;
	    case 3:  // arq - define o arquivo onde pesquisar tpicos
	       proxpal(lin,palavra,&p,tam);
	       if(strlen(palavra))
		  strcpy(arquivo_pesquisa,palavra);
	       else
		  strcpy(arquivo_pesquisa,NOME_ARQ_AJUDA);
	       ajuda("");
	       break;
	    case 4: // ls
	    case 5: // dir
	       fprintf(SAIDA,"\nARQUIVOS DE DOCUMENTAO:\n\n");
#ifdef LINUX
	       sprintf(palavra,LIST_COMMAND,NOME_DIR_AJUDA);
#else
	       sprintf(palavra,LIST_COMMAND,diretorio_pesquisa);
#endif
	       //printf(palavra);
#ifdef LISTAGEM
	       system(palavra); //no funciona em Win16
#else
	       fprintf(SAIDA,"Este comando no funciona nesta compilao.\n");
#endif
	       break;
	    case 6: // pausar
	       pausar = !pausar;
	       if(pausar)
		  fprintf(SAIDA,
			  "\n PAUSA ATIVADA - Textos longos sero exibidos tela a tela.\n");
	       else
		  fprintf(SAIDA,
		    "\n PAUSA DESATIVADA - Textos longos sero exibidos sem interrupo.\n");
	       break;
	       //case 7:
	       //if(proxpal(lin,palavra,&p,tam))
	       //   lenumero(palavra);
	       //else
	       //   impr_erro("ERA ESPERADO UM NUMERO");
	       //break;
	    default:
	       break;
	    }
	 }
      }
   }
   exit(0);
   //return;
}

//rotinas de entrada e saida:

int impr_saida(char s[])
{
   fprintf(arq_saida,"%s",s);
   return;
}

int impr_erro(char s[])
{
   fprintf(ERRO,"\nERRO: %s\n",s);
   return;
}

int lelinha(s,lim,ap_arquivo)
     char s[];
     int lim;
     FILE *ap_arquivo;
{
   int c,i;

   for(i=0; i<lim-1&&(c=fgetc(ap_arquivo))!=EOF&&c!='\n';i++)
      s[i]=(char)c;
   if(c=='\n') {
      s[i]=(char)c;
      i++;
   }
   s[i]='\0';
   return(i);
}

int proxpal(s,pal,pos,lim) //retorna tamanho da palavra
     char s[], pal[];
     int *pos,lim;
{
   int i;
   while(separador(s[*pos])&&*pos<=lim)
      (*pos)++;

   i=0;
   while(*pos<=lim && s[*pos]!='\0' && !separador(s[*pos])) {
      pal[i]=s[*pos];
      i++,(*pos)++;
   }
   pal[i]='\0';
   return(i);
}

int separador(c)
     char c;
{
#define NSEP 5
   char sep[NSEP] = {',',' ','\n','\t','\b'};
   int i;
   for(i=0;i<=NSEP;i++)
      if(c==sep[i])
	 return(1);
   return(0);
}

int ident_com(char pal[],char *lista[],int n_com)
{
   int i;
   for(i=0;i<n_com;i++)
      if(strcmpi(pal,lista[i])==0)
	 return(i);
   return(-1);
}

int ajuda(char pal[])
{
   FILE *ap_arq_aj, *fopen();
   int c, p, i, todos, cont, inicio, lb, contlin;
   char buf[MAXLIN];
   char arquivo_de_ajuda[BUFSIZ];
   char *palproc;
   char msg[BUFSIZ];
   char sep[8];
   //char *topico_default = TOPICO_DEFAULT;
   int cont_sinal_topico=0;


   todos=NAO;
   inicio=SIM;
   cont=0;
   contlin=0;
   //clrscr(); // se for compilado para DOS

   sprintf(sep,"%c",DIRSEP);
   sprintf(msg,"NO FOI POSSVEL ABRIR O ARQUIVO ");
   arquivo_de_ajuda[0]='\0';
   //strcpy(arquivo_de_ajuda, chamada);
   //strcat(arquivo_de_ajuda, NOME_DIR_AJUDA);
   //strcat(arquivo_de_ajuda, sep);
   //strcat(arquivo_de_ajuda, arquivo_pesquisa);

   if(strchr(arquivo_pesquisa,'.')==NULL) {
      strcat(arquivo_pesquisa, EXT_ARQ_AJUDA);
   }
   strcpy(arquivo_de_ajuda, diretorio_pesquisa);
   strcat(arquivo_de_ajuda, arquivo_pesquisa);


   if((ap_arq_aj = fopen(arquivo_de_ajuda,"r")) == NULL) {
      strcat(msg,arquivo_de_ajuda);
      impr_erro(msg);
      strcpy(arquivo_pesquisa,NOME_ARQ_AJUDA);
      fprintf(ERRO,"ARQUIVO DE PESQUISA REDIRECIONADO PARA %s%s\n\n",
	      diretorio_pesquisa,arquivo_pesquisa);
      return(1);
   }
   palproc = pal;
   if(!strlen(palproc)) {
      palproc = TODOS_OS_TOPICOS;
      todos=SIM;
   }

   //contlin=0;
   do {

      //while((c=fgetc(ap_arq_aj))!=EOF && c!=SINAL_NOME_TOPICO)
      //		;
      cont_sinal_topico=0;
      while((c=fgetc(ap_arq_aj))!=EOF) {
	 if(c==SINAL_NOME_TOPICO)
	    cont_sinal_topico++;
	 else
	    cont_sinal_topico=0;
	 ;
	 if(cont_sinal_topico>=2)
	    break;
      }
      i = 0;
      while(i<MAXLIN && (c=fgetc(ap_arq_aj))!=EOF && c!='\n') {
	 buf[i++] = (char)c;
      }
      buf[i]='\0';




      //printf(" topico procurado: %s\n", palproc);
      //printf(" pesquisando: %10.10s...\n", buf);



      if(todos==SIM) {
 
	 if(contlin==0 || contlin>=23) {
	    if(pausar && contlin>=23) {
	       fprintf(SAIDA,"PRESSIONE <ENTER> PARA CONTINUAR");
	       getch();
	    }
	    if((pausar) || contlin<10) {
	       fprintf(SAIDA, "\nARQUIVO \"%s\"",arquivo_pesquisa);
	       fprintf(SAIDA, "  -  TPICOS DISPONVEIS");
	    }
	    if(inicio==SIM)  {
	       fprintf(SAIDA,":\n\n");
	       cont++;
	       contlin=2; //conferir!!!!
	    }
	    //#ifndef EASY_WIN
	    else {
	       if(pausar) {
		  fprintf(SAIDA, " (CONTINUAO):\n");
		  contlin=1;
	       }
	  
	    }
	    inicio=NAO;
	    //#endif
	 }
	 if(strlen(buf)>19) {
	    fprintf(SAIDA,"\n%s\n", buf);
	    cont=1;
	    contlin += 1;
	 }
	 else if (strlen(buf)==0) {
	    fprintf(SAIDA,"\n");
	    cont=1;
	    contlin++;
	 }
	 else
	    fprintf(SAIDA,"%-19s", buf);
	 cont++;
	 if(!(cont%5)) {
	    fprintf(SAIDA,"\n");
	    contlin++;
	    cont=1;
	 }
	 inicio = NAO;
      }

   } while(strcmp(palproc,buf)&&c!=EOF);

   /*
     if(!strcmp(palproc,buf))
     while((c=fgetc(ap_arq_aj))!=EOF && c!='$')
     fputc(c,ERRO);
     else
     fprintf(ERRO,"Tpico \"%s\" inexistente no arquivo %s\n",palproc,arquivo_de_ajuda);

     fclose(ap_arq_aj);
     return(0);
   */
   p='\n'; /* caracter anterior */
   if(!strcmp(palproc,buf)) {
      cont = 0;

      while((c=fgetc(ap_arq_aj))!=EOF && !(c==SINAL_INICIO_TOPICO && p=='\n'))
	 p=c;

      /*cont_sinal_topico=0;
	while((c=fgetc(ap_arq_aj))!=EOF) {
	if(c==SINAL_NOME_TOPICO) // SINAL_INICIO_TOPICO
	cont_sinal_topico++;
	else
	cont_sinal_topico=0;
	;
	if(cont_sinal_topico>=2)
	break;
	}*/

      while((c=fgetc(ap_arq_aj))!=EOF &&
	    !(c==SINAL_FIM_TOPICO && p=='\n')){//&& c!=SINAL_NOME_TOPICO) {
	 //#ifndef EASY_WIN
	 //if(p!='\n') fprintf(stderr,"p=%c",p);
	 p=c;
	 if( pausar && cont==23 ) {
	    fprintf(SAIDA, "*************** ");
	    fprintf(SAIDA, "...PRESSIONE <ENTER> PARA CONTINUAR...");
	    fprintf(SAIDA, " ***************");
	    if(getch()=='\n') /* linux */
		    cont=2;
	    else
		    cont=1;
	    fprintf(SAIDA,"\n");
	    lb = strlen(buf);
	    lb=(80-lb-63)/2; // centraliza
	    while(lb--) fprintf(SAIDA,"");
	    fprintf(SAIDA,"******************* TPICO \"");
	    fprintf(SAIDA, buf);
	    fprintf(SAIDA, "\" (CONTINUADO) *******************\n");
	    /*cont=0;*/
	 };
	 //#endif
	 fputc(c,SAIDA);
	 if(c=='\n')
	    cont++;
      }
   }
   else if(todos==NAO) {
      fprintf(SAIDA,"\nTPICO \"");
      fprintf(SAIDA, palproc);
      fprintf(SAIDA, "\" INEXISTENTE NO ARQUIVO \"");
      fprintf(SAIDA, "%s\"\n\n", arquivo_pesquisa);
   }
   fprintf(SAIDA,"\n");
   fclose(ap_arq_aj);
   return(0);
}
/*
  int lenumero(char s[])
  {
  //int i;
  double numero;
  switch(conv_num(s,&numero)) {
  case (0): //sucesso
  fprintf(arq_saida,"%g\n",numero);
  break;
  case (-1):  //nao e numero
  fprintf(arq_saida,"Impossivel converter numero\n");
  break;
  case (-2):
  fprintf(arq_saida,"Numero muito grande\n");
  break;
  }

  return;
  }

  int conv_num(char s[], double *num) //converte string a numero
  {
  //int i;
  char *endptr;
  if(strtod(s,&endptr)!=HUGE_VAL && strtod(s,&endptr)!=-HUGE_VAL) {
  *num=strtod(s,&endptr);
  if(*endptr!='\0') {
  //printf("parou em \'%c\'\n",*endptr);
  return(-1); //nao  numero
  }
  return(0);  //sucesso
  }
  return(-2); //numero muito grande
  }
*/

