/* PROGRAMA PARA GERAR ARQUIVO DE AJUDA DE abcAJUDA */
/*           Hudson Lacerda (2004-2005)             */
/*     (Renascendo em 27 de dezembro de 2004)       */
/*         (ltima reviso em 04/01/2005)           */

/* AFAZERES:
 * - Geracao de documentacao mista (com itens nao presentes no arquivo_ps);
 * - Conversao ABCH -> HTML
 * - Sada em formato LaTeX
 * - revisar `pesquisa()' : tratamento suspeito da string
 * - incorporacao de `obtem_operadores.c' como uma funcao neste programa
 * - lidar com terminacao de linha de DOS (ser necessrio?)
 */

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define PS   0 /*tipo de entrada (operadores postscript)*/
#define FMT  1 /*tipo de entrada (comandos de formato - arquivo `format.txt')*/
#define OP   2 /*tipo de entrada (comandos de formato - arquivo `options.txt')*/
#define TXT  3 /*tipo de entrada (arquivo de texto plano) saida com COPYRIGHT */
#define GENERICO -1

#define HTML 1 /*tipo de saida*/
#define ABCH 0 /*tipo de saida*/

#define NO_SPAM 1 /* quando saida  HTML, substitui caracteres @ por (a) */
#define SPAM    0 /* quando saida  HTML, mantm caracteres @            */

#define ABCM    1 /* imprime titulo e nota de copyright   */
#define NO_ABCM 0 /* nao imprime titulo nota de copyright */

#define MAXTOPICOS 512 /* numero maximo de topicos (no indice) */

int main(int argc, char *argv[]);
int printld_if(long int n, int m);
int put2c(int p,int c);
int pesquisa(char palavra[], FILE *arquivo, int opcao);
int branco(int c);
int uso(void);
int imprime_inicio(int opcao);
int imprime_copyright(void);
int imprime_final(void);
int simbolo_html(char *s,char c);


char buffer[BUFSIZ];

int main (int argc, char *argv[])
{
	int c,p,pp,m,i,j,cont,condicao;
	long int n;
	char nome[BUFSIZ], nome2[BUFSIZ], nomearq1[BUFSIZ];
	char codigohtml[16], nomecurto[BUFSIZ];
	FILE *arquivo1, *fopen();
  
	int tipoentrada = PS; /* default */
	int tiposaida = HTML; /* default */
	int nospam = SPAM;    /* default */
	int abcm = ABCM;      /* default */

	char topicos[MAXTOPICOS][BUFSIZ];

	m=0;
	cont=0;

	if(argc==1) {
		uso();
		return 0;
	}

	/* Processa linha de comando */
	for(c=1; c<argc; c++) {
		/* printf("%s\n",argv[c]); */
		if(strcasecmp(argv[c], "L")==0)
			m=1; /* opcao L : imprime numeros de linhas (debug) */
		if(strcasecmp(argv[c], "PS")==0)
			tipoentrada=PS;
		if(strcasecmp(argv[c], "OP")==0)
			tipoentrada=OP;
		if(strcasecmp(argv[c], "FMT")==0)
			tipoentrada=FMT;
		if(strcasecmp(argv[c], "TXT")==0)
			tipoentrada=TXT;
		if(strcasecmp(argv[c], "HTML")==0)
			tiposaida=HTML;
		if(strcasecmp(argv[c], "ABCH")==0)
			tiposaida=ABCH;
		if(strcasecmp(argv[c], "ABCM")==0) /* inclui nota de copyright */
			abcm=ABCM;
		if(strcasecmp(argv[c], "NO_ABCM")==0)
			abcm=NO_ABCM;
		if(strcasecmp(argv[c], "NO_SPAM")==0) /* substitui caracter @ por (a) */
			nospam=NO_SPAM;
		if(strcasecmp(argv[c], "@")==0) /* no altera caracter @ */
			nospam=SPAM;
		/*if(strcasecmp(argv[c], "TODOS")==0)
		  todos=1;*/
		if(c==(argc-1)) {/* ultimo argumento = nome do arquivo de descricao */
			sprintf(nomearq1,argv[c]);
			strcpy(buffer,nomearq1);
		}
	}

	if(tiposaida==HTML) {
		if(abcm==ABCM)
			imprime_inicio(tipoentrada);
		else
			imprime_inicio(GENERICO);
	}
	else //if(tipoentrada==TXT)
		printf("\n@@LEIA-ME\n$\n"); /* inicio ABCH : tpico default */

	pp=p='\0';
	n=1L;
	while((c=getchar())!=EOF) {
		if(c=='\n') n++;
		
		/*if(c=='\b') c='\n';*/
		
		if(tipoentrada==PS)
			condicao = (p=='\n' && c=='/'); /* identificador postscript */
		else if(tipoentrada==TXT) {
			condicao=0; /* texto plano */
		}
		else
			condicao = (pp=='\n' && p==' ' && c==' ');/* com. de formato */

		if(condicao) {
			/* imprime separador de topico antes de um novo topico */
			if(tiposaida==HTML && tipoentrada!=TXT) {
				printf("</pre><a href=#indice>IR PARA O NDICE</a> "
				       "<a href=#inicio>IR PARA O INCIO</a>"
				       "<hr>\n\n");
			}
			else /* ABCH */
				printf("\n$\n");
			/* */
			printld_if(n,m);

			i=0;
			nome[0]='\0';
			/*pega nome*/
			while((c=getchar())!=' ' && c!='{' && c!='/' &&
			      c!='\n' && c!='\b' && c!=EOF){
				if(i<(BUFSIZ-4)) { /* reserva para codigo html */
					if(tiposaida==HTML && simbolo_html(codigohtml,c)) {
						nome[i++]='&';
						nome[i++]=(c=='<')?'l':'g';
						nome[i++]='t';
						nome[i++]=';';
					}
					else
						nome[i++]=c;
				}
				/* pp=p; p=c; */
			}
			
			if(c=='\n')
				n++;
			//if(c=='\b') c=' ';

			nome[i]='\0';
			
			if(tipoentrada==OP)
				sprintf(nomecurto,"%.2s",nome);
			else
				strcpy(nomecurto,nome);

			/* imprime identificador do topico */
			if(tiposaida==HTML) {
				/* titulo do topico e referencia para link */
				printf("<a name=%s><h1><i>%s</i></h1></a>",
				       nomecurto,nomecurto);
			}
			else { /* ABCH */
				put2c('@','@');
				printf(nomecurto);
				printf("\n$\n");
				printf(nomecurto);
			}
			/* */

			printf("\n");
			if((arquivo1=fopen(nomearq1,"rt"))!=NULL) { /* acrescenta anotacoes */
				sprintf(nome2,"@@%s",nome);
				/* formatacao do texto descritivo (inicio) */
				if(tiposaida==HTML) {
					printf("<pre><b>");
				}
				else /* ABCH */
					;
				/* */

				/*pesquisa e imprime descricao*/
				pesquisa(nome2,arquivo1,tiposaida);
				fclose(arquivo1);
				/* formatacao do texto descritivo (fim) */
				if(tiposaida==HTML) {
					printf("</b></pre>");
				}
				else /* ABCH */
					;
				/* */
			}
			printf("\n");
			/* imprime o nome como identificador PS */
			if(tiposaida==HTML) {
				printf("<pre>");
				if(cont<MAXTOPICOS) /* coloca na lista de topicos */
					strcpy(topicos[cont++],nomecurto);
				else
					fprintf(stderr,"BUFFER CHEIO: topicos[%d]\n",cont-1);
			}
			if(tipoentrada==PS)
				printf("/"); /* postscript */
			printf(nome); /* nome */

			if(c=='\n')
				n++;
			/* conferir!: */
			/*pp=p; p=c;*/ /* conferir! */
		}
		if(tiposaida==HTML) {
			if(simbolo_html(codigohtml,c))
				printf(codigohtml);
			else if (c=='@' && nospam) /* anti-spam: substitui @ por (a) */
				printf("<b><i><small><small>"
				       "(a)"
				       "</small></small></i></b>");
			else
				putchar(c);
		}
		else
			putchar(c); /*imprime o resto, caracter por caracter*/
		pp=p; p=c; /* guarda caracteres anteriores */
	}

	/* imprime indice */
	if(tiposaida==HTML && tipoentrada!=TXT) {
		printf("</pre><a href=#indice>IR PARA O NDICE</a> "
		       "<a href=#inicio>IR PARA O INCIO</a>"
		       "<hr>\n\n");
		qsort(topicos, 	           /* Pointer to elements		*/
		      cont, 	           /* Number of elements		*/
		      sizeof(topicos[0]),  /* size of one element.		*/
		      (void *)strcasecmp   /* Pointer to comparison function    */
		      );
		printf("<a name=indice><h1><i>ndice</i></h1></a>");
		printf("\n<p><b>\n");
		/* imprime indice de topicos */
		for(c=0;c<cont;c++)
			printf("<a href=#%s>%s</a> %c \n",
			       topicos[c],topicos[c],
			       c==(cont-1)?' ':'|');
		printf("</b></p>");
		/* imprime numero de topicos do arquivo */
		printf("\n\n<p>(%d tpicos)</p>\n\n",c);
	
		printf("<a href=#indice>IR PARA O NDICE</a> "
		       "<a href=#inicio>IR PARA O INCIO</a>");
	}
	/* finaliza arquivo HTML */
	if(tiposaida==HTML) {
		if(abcm==ABCM)
			imprime_copyright();
		imprime_final();
	}
	else //if(tipoentrada==TXT)
		printf("\n$\n"); /* fim ABCH */
  
	return 0;
}

int printld_if(long int n, int m)
{
	if(m)
		printf("L%4ld: \n",n);
	return (0);
}

int put2c(int p,int c)
{
	putchar(p);
	putchar(c);
	return (0);
}

int pesquisa(char palavra[], FILE *arquivo, int opcao)
{
	int c, p, i, j;
	char s[BUFSIZ],t[BUFSIZ];
	p='\n';
	while((fgets(t,BUFSIZ,arquivo))!=NULL) {
		strcpy(s,t);
		/* pega primeira palavra */
		i=0;
		while(i<BUFSIZ && t[i]!='\0') {
			if(!branco(t[i])) /* se no  branco */
				break;
			i++;
		}
		i=0; j=0;
		while(i<BUFSIZ && t[i]!='\0') {
			if(branco(t[i]))  /* se  branco */
				break;
			s[j]=t[i];
			i++; j++;
		}
		s[j]='\0';
		/*fprintf(stderr,"\n:%s:\n",s);*/

		if(strcmp(palavra,s)==0) {
			while((c=fgetc(arquivo))!=EOF &&
			      !(c=='$' && p=='\n')) /*ignora*/
				p=c;
			while((c=fgetc(arquivo))!=EOF &&
			      !(c=='$' && p=='\n')) { /*captura*/
				if(opcao==HTML && simbolo_html(s,c))
					printf(s);
				else
					putchar(c);
				p=c;
			}
			break;
		}
	}
	return 0;
}

int branco(int c) { /* verifica se  espao em branco */
	switch(c) {
		/* case '\0': */
	case ' ':
	case '\n':
	case '\t':
	case '\v':
	case '\b':
	case '\r':
	case '\f':
		return 1;
	default:
		return 0;
	}
}

int imprime_inicio(int opcao)
{
	char titulo[BUFSIZ];
	if(opcao==PS) /* opcao = tipoentrada */
		sprintf(titulo,"Operadores PostScript de abcm2ps");
	else if(opcao==OP)
		sprintf(titulo,"Opes de Linha de Comando de abcm2ps");
	else if(opcao==TXT)
		sprintf(titulo,"Documentao de abcm2ps (%s)",buffer); /*buffer global*/
	else if(opcao==FMT)
		sprintf(titulo,"Parmetros de Formato de abcm2ps");
	else /* GENERICO */
		sprintf(titulo,"(%s)",buffer); /*buffer global*/



	printf("<html><head>\n"
	       "<meta http-equiv=\"Content-Type\" "
	       "content=\"text/html; charset=iso-8859-1\">\n");
	printf("<title>%s</title></head>\n",titulo);
	printf("<body bgcolor=\"#ffffaa\"><hr>"
	       "<a name=inicio></a><a ref=inicio>\n");
	printf("<h1>%s</h1></a>\n",titulo);
	printf("<pre>\n\n");
	return 0;
}


int imprime_copyright(void)
{
	printf("</pre><hr>\n"
	       "<h4>Copyright (C) 2004-2005 Hudson Lacerda</h4>"
	       "\n"
	       "<small><p>This document is based on <b>abcm2ps</b>: "
	       "\n"
	       "Copyright (C) 1998-2005 Jean-Franois Moine, adapted from "
	       "\n"
	       "<b>abc2ps-1.2.5</b>: Copyright (C) 1996,1997  Michael Methfessel."
	       "\n"
	       "Released under the terms of the GNU General Public License, Version 2."
	       "\n"
	       "</p><p>Este documento  baseado em <b>abcm2ps</b>: "
	       "\n"
	       "Copyright (C) 1998-2005 Jean-Franois Moine, "
	       "por sua vez adaptado de <b>abc2ps-1.2.5</b>:"
	       "\n"
	       "Copyright (C) 1996,1997  Michael Methfessel."
	       "\n"
	       "Distribudo segundo os termos da Licena Pblica Geral do GNU, Verso 2."
	       "</p></small>\n"
	       "A verso mais recente deste documento pode ser obtida em:<br>"
	       "<a href=\"http://geocities.yahoo.com.br/hfmlacerda/\">"
	       "http://geocities.yahoo.com.br/hfmlacerda/</a> "
	       "<i>(Hudson Lacerda)</i>"
	       "<pre>");
	return 0;
}

int imprime_final(void)
{
	printf("</pre>\n<hr>\n\n</body></html>\n");
}

int simbolo_html(char *s, char c)
{
	if(c=='>') {
		sprintf(s,"&gt;");
		return 1;
	}
	else if(c=='<') {
		sprintf(s,"&lt;");
		return 1;
	}
	s[0]='\0';
	return 0;
}

int uso(void)
{
	fprintf(stderr,
		"\nPrograma para gerar documentacao de abcm2ps\n"
		"(c) 2004-2005 Hudson Lacerda\n"
		/*" (PARA abcAJUDA)\n"*/
		"\nmodo de uso:\n"
		"gera_ajuda [OP_ENT] [OP_SAI] [OP@] [OP_ABCM] arq_descricao < arq_ent > arq_sai\n"
		"\nOP_ENT deve ser:    PS     PostScript\n"
		"                    FMT    `format.txt'\n"
		"                    OP     `options.txt'\n"
		"              ou    TXT    texto plano\n"
		"\nOP_SAI deve ser:    HTML\n"
		"              ou    ABCH\n"
		"\nOP@ deve ser:       @      Mantm caracter @\n"
		"           ou       NO_SPAM    Substitui caracter @ por (a)\n"
		"    OP@ s tem efeito se OP_SAI  HTML.\n"
		"\nOP_ABCM deve ser:   ABCM   Imprime ttulo e nota de copyright\n"
		"               ou   NO_ABCM    No imprime nota de copyright\n"
		"    OP_ABCM s tmm efeito se OP_SAI  HTML."
		"\n\n");
}
